#include <SDL.h>
#include <stdlib.h>
#include <stdarg.h>
#include "vgalib.h"

unsigned offst[1024];
extern int MAXX, MAXY;
SDL_Surface *surface;
Uint8 *buffer;

void panic(const char *fmt, ...)
{
    va_list arg;

    va_start(arg, fmt);
    vfprintf(stderr, fmt, arg);
    va_end(arg);
    exit(0);
}

void init256()
{
    if (SDL_Init(SDL_INIT_VIDEO) < 0)
        panic("Couldn't initialize SDL: %d\n", SDL_GetError());
    atexit(SDL_Quit);

    surface = SDL_SetVideoMode(MAXX,
                               MAXY, 8, SDL_HWSURFACE | SDL_HWPALETTE);
    if (!surface)
        panic("Couldn't set video mode: %d", SDL_GetError());

    if (SDL_MUSTLOCK(surface)) {
        if (SDL_LockSurface(surface) < 0)
            panic("Couldn't lock surface: %d", SDL_GetError());
    }
    buffer = (Uint8*)surface->pixels;
    {
        int i;
        for (i = 0; i < MAXY; i++)
            offst[i] = i * MAXX;
    }
}

void close256()
{
}


void qplot(int r, int k, int l)
{
    *(buffer + offst[k] + r) = l;
}

Uint8 qget(int r, int k)
{
    return *(buffer + offst[k] + r);
}

int kbhit()
{
    SDL_Event event;

    if (SDL_PollEvent(&event)) {
        if (event.type == SDL_KEYDOWN)
            return 1;
    }
    return 0;
}

void pal()
{
    int i;
    SDL_Color palette[256];

    for(i=0; i<256; i++) {
        palette[i].r = i;
        palette[i].g = i;
        palette[i].b = i;
    }
    SDL_SetColors(surface, palette, 0, 256);
}

void showpage(void)
{
    if (SDL_MUSTLOCK(surface)) {
	SDL_UnlockSurface(surface);
    }
    SDL_UpdateRect(surface, 0, 0, MAXX, MAXY);
    if (SDL_MUSTLOCK(surface)) {
        if (SDL_LockSurface(surface) < 0)
            panic("Couldn't lock surface: %d", SDL_GetError());
    }
}
